using System;
using System.Drawing;
using Syncfusion.Diagram.Windows.Text;
using System.ComponentModel;
using System.Windows.Forms;

using System.Runtime.Serialization;
using System.Drawing.Drawing2D;

using Syncfusion.Windows.Forms.Diagram;

namespace Fixed_TextNode
{
	/// <summary>
	/// Summary description for MySymbol.
	/// </summary>
	[Serializable()]
	public class FixedSymbolLabel : Symbol
	{
		private Syncfusion.Windows.Forms.Diagram.Rectangle outerRect = null;
		private Syncfusion.Windows.Forms.Diagram.Label lbl=null;
		public string strDescription = "Custom Symbol";	
				
		public FixedSymbolLabel()
		{
			//////////////////////////////////////////////////////////////////
			// Add child nodes to the symbol programmatically
			//////////////////////////////////////////////////////////////////

			// Add an outer rectangle
			this.outerRect = new Syncfusion.Windows.Forms.Diagram.Rectangle(0, 0, 120, 80);
			this.outerRect.Name = "Rectangle1";
			this.outerRect.FillStyle.Type = Syncfusion.Windows.Forms.Diagram.FillStyleType.LinearGradient;
			this.outerRect.FillStyle.Color = Color.Orange;
			this.outerRect.ShadowStyle.Visible = true;
			this.AppendChild(outerRect);

			lbl =this.AddLabel("Label",BoxPosition.Center);
			lbl.Text="ResizeLabel";
			lbl.BackgroundStyle.Color = Color.Transparent;
			lbl.Location=new PointF(10,20);
			lbl.Name="SymbolLabel";
			lbl.ReadOnly = true;
			
			
														
		}

		/// <summary>
		/// Serialization constructor for symbols.
		/// </summary>
		/// <param name="info">Serialization state information</param>
		/// <param name="context">Streaming context information</param>
		protected FixedSymbolLabel(SerializationInfo info, StreamingContext context) : base(info, context)
		{
			this.strDescription = info.GetString("strDescription");
		}

		/// <summary>
		/// This property provides an example of adding a member variable to a custom symbol
		/// and demonstrates how to handle serialization for this property.
		/// </summary>
		[
		Browsable(true),
		Category("General"),
		Description("Description of the symbol"),
		DesignerSerializationVisibility(DesignerSerializationVisibility.Visible)
		]
		public string Description
		{
			get
			{
				return this.strDescription;
			}
			set
			{
				this.strDescription = value;
			}
		}

		/// <summary>
		/// Populates a SerializationInfo with the data needed to
		/// serialize the target object.
		/// </summary>
		/// <param name="info">SerializationInfo object to populate</param>
		/// <param name="context">Destination streaming context</param>
		protected override void GetObjectData(SerializationInfo info, StreamingContext context)
		{
			base.GetObjectData(info, context);

			// Additional member variables are serialized here
			info.AddValue("strDescription", this.strDescription);
		}

		/// <summary>
		/// Called when deserialization is complete.
		/// </summary>
		/// <param name="sender">Object performing the deserialization</param>
		protected override void OnDeserialization(object sender)
		{
			base.OnDeserialization(sender);

			// Get references to the child objects
			this.outerRect = this.GetChildByName("Rectangle1") as Syncfusion.Windows.Forms.Diagram.Rectangle;
						
		}	

	

	}
}
